# Copyright © 2020 Gregor Reitzenstein
# Licensed under the MIT License:
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the "Software"),
# to deal in the Software without restriction, including without limitation
# the rights to use, copy, modify, merge, publish, distribute, sublicense,
# and/or sell copies of the Software, and to permit persons to whom the
# Software is furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
# OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
# IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
# DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
# TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
# OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.


@0x9e1c146a27dcc635;

using Auth = import "auth.capnp";

struct Message {
    union {
        hello @0 :Hello;
        bye @1 :Bye;
        starttls @2 :Void;
        auth @3 :Auth.Message;
    }
}

struct Hello {
    # Be nice and say hello to each other first
    # A client sends this message to a server first thing

    major @0 :UInt32; # The major part of the API version
    minor @1 :UInt32; # The minor part of the API version
}

struct Bye {
    # Tear down a connection nicely.

    enum Reason {
        unset @0; # Just cause

        versionMismatch @1;
        # The server doesn't implement a compatible version of the protocol
    }

    reason @0 :Reason;
}
